From cc885ea12626403ba57680455336c4aa722b8a1c Mon Sep 17 00:00:00 2001
From: Chenxiong Qi <cqi@redhat.com>
Date: Jan 03 2018 05:41:10 +0000
Subject: [PATCH 1/7] Rewrite finding dependent events


Signed-off-by: Chenxiong Qi <cqi@redhat.com>

---

diff --git a/freshmaker/handlers/errata/errata_advisory_rpms_signed.py b/freshmaker/handlers/errata/errata_advisory_rpms_signed.py
index 799bb4b..53b04bc 100644
--- a/freshmaker/handlers/errata/errata_advisory_rpms_signed.py
+++ b/freshmaker/handlers/errata/errata_advisory_rpms_signed.py
@@ -161,37 +161,14 @@ class ErrataAdvisoryRPMsSignedHandler(ContainerBuildHandler):
 
         return new_compose
 
-    def _prepare_yum_repos_for_rebuilds(self, db_event, event, builds):
+    def _prepare_yum_repos_for_rebuilds(self, db_event):
         repo_urls = []
         repo_urls.append(self._prepare_yum_repo(db_event))  # noqa
 
-        # Find out extra events we want to include. These are advisories
-        # which are not released yet and touches some Docker images which
-        # are shared with the initial list of docker images we are going to
-        # rebuild.
-        # If we For example have NSS Errata advisory and httpd advisory, we
-        # need to rebuild some Docker images with both NSS and httpd
-        # advisories.
-        # We also want to search for extra events recursively, because there
-        # might for example be zlib advisory, and we want to include this zlib
-        # advisory when rebuilding NSS when rebuilding httpd... :)
-        prev_builds_count = 0
-        seen_extra_events = []
-
-        # We stop when we did not find more docker images to rebuild and
-        # therefore cannot find more extra events.
-        while prev_builds_count != len(builds):
-            prev_builds_count = len(builds)
-            extra_events = self._find_events_to_include(db_event, builds)
-            self.log_info("Extra events: %r", extra_events)
-            for ev in extra_events:
-                if ev in seen_extra_events:
-                    continue
-                seen_extra_events.append(ev)
-                db_event.add_event_dependency(db.session, ev)
-                for batches in self._find_images_to_rebuild(ev.search_key):
-                    builds = self._record_batches(batches, event, builds)
-                repo_urls.append(self._prepare_yum_repo(ev))
+        repo_urls += [
+            self._prepare_yum_repo(dep_event)
+            for dep_event in db_event.find_dependent_events()
+        ]
 
         db.session.commit()
         # Remove duplicates from repo_urls.
@@ -411,30 +388,6 @@ class ErrataAdvisoryRPMsSignedHandler(ContainerBuildHandler):
 
             batch += 1
 
-    def _find_events_to_include(self, db_event, builds):
-        """
-        Find out all unreleased events which built some image which is also
-        planned to be built as part of current image rebuild.
-
-        :param db_event Event: Database representation of
-            ErrataAdvisoryRPMsSignedEvent.
-        :param builds dict: list of docker images to build as returned by
-            _find_images_to_rebuild(...).
-        """
-        events_to_include = []
-        for ev in Event.get_unreleased(db.session):
-            for build in ev.builds:
-                # Skip non IMAGE builds
-                if (build.type != ArtifactType.IMAGE.value or
-                        ev.message_id == db_event.message_id):
-                    continue
-
-                if build.name in builds:
-                    events_to_include.append(ev)
-                    break
-
-        return events_to_include
-
     def _record_batches(self, batches, event, builds=None):
         """
         Records the images from batches to database.
diff --git a/freshmaker/models.py b/freshmaker/models.py
index f88cf00..72830c4 100644
--- a/freshmaker/models.py
+++ b/freshmaker/models.py
@@ -310,6 +310,40 @@ class Event(FreshmakerBase):
             "builds": [b.json() for b in self.builds],
         }
 
+    def find_dependent_events(self):
+        """
+        Find other unreleased Events which built the same builds (or just some
+        of them) as this Event and adds them as a dependency for this event.
+
+        Dependent events of may also rebuild some same images that current event
+        will build. So, for building images found from current event, we also
+        need those YUM repositories used to build images in dependent events.
+        """
+        builds_nvrs = [build.name for build in self.builds]
+
+        states = [EventState.INITIALIZED.value,
+                  EventState.BUILDING.value,
+                  EventState.COMPLETE.value]
+
+        query = db.session.query(ArtifactBuild.event_id)
+        dep_event_ids = query.join(ArtifactBuild.event).filter(
+            ArtifactBuild.name.in_(builds_nvrs),
+            ArtifactBuild.event_id != self.id,
+            ArtifactBuild.type == ArtifactType.IMAGE.value,
+            Event.manual_triggered == false(),
+            Event.released == false(),
+            Event.state.in_(states),
+        ).distinct()
+
+        dep_events = []
+        query = db.session.query(Event)
+        for row in dep_event_ids:
+            dep_event = query.filter_by(id=row[0]).first()
+            self.add_event_dependency(db.session, dep_event)
+            dep_events.append(dep_event)
+        db.session.commit()
+        return dep_events
+
 
 class EventDependency(FreshmakerBase):
     __tablename__ = "event_dependencies"
diff --git a/tests/test_errata_advisory_state_changed.py b/tests/test_errata_advisory_state_changed.py
index 78c0cd2..0fa60e5 100644
--- a/tests/test_errata_advisory_state_changed.py
+++ b/tests/test_errata_advisory_state_changed.py
@@ -24,7 +24,7 @@
 import unittest
 import json
 
-from mock import patch, MagicMock, PropertyMock, Mock, call
+from mock import patch, PropertyMock, Mock, call
 
 from freshmaker.handlers.errata import ErrataAdvisoryRPMsSignedHandler
 from freshmaker.handlers.errata import ErrataAdvisoryStateChangedHandler
@@ -730,53 +730,6 @@ class TestFindImagesToRebuild(unittest.TestCase):
         self.assertEqual([], ret)
 
 
-class TestFindEventsToInclude(unittest.TestCase):
-    """Test ErrataAdvisoryRPMsSignedHandler._find_events_to_include"""
-
-    def setUp(self):
-        db.session.remove()
-        db.drop_all()
-        db.create_all()
-        db.session.commit()
-
-        self.db_event = Event.get_or_create(
-            db.session, "msg1", "current_event", ErrataAdvisoryRPMsSignedEvent,
-            released=False)
-        ArtifactBuild.create(db.session, self.db_event, "foo", "image", 0)
-
-        # Only this event should be reused, because it is unreleased and
-        # contains the foo build.
-        ev = Event.get_or_create(
-            db.session, "msg2", "old_event_foo", ErrataAdvisoryRPMsSignedEvent,
-            released=False)
-        ev.state = EventState.COMPLETE
-        ArtifactBuild.create(db.session, ev, "foo", "image", 0)
-
-        ev = Event.get_or_create(
-            db.session, "msg3", "old_event_foo_released",
-            ErrataAdvisoryRPMsSignedEvent, released=True)
-        ArtifactBuild.create(db.session, ev, "foo", "image", 0)
-
-        ev = Event.get_or_create(
-            db.session, "msg4", "old_event_bar", ErrataAdvisoryRPMsSignedEvent,
-            released=False)
-        ArtifactBuild.create(db.session, ev, "bar", "image", 0)
-        db.session.commit()
-
-    def tearDown(self):
-        db.session.remove()
-        db.drop_all()
-        db.session.commit()
-
-    def test_find_events_to_include(self):
-        builds = {"foo": MagicMock()}
-        handler = ErrataAdvisoryRPMsSignedHandler()
-        events = handler._find_events_to_include(self.db_event, builds)
-
-        self.assertEqual(len(events), 1)
-        self.assertEqual(events[0].search_key, "old_event_foo")
-
-
 class TestErrataAdvisoryStateChangedHandler(unittest.TestCase):
 
     def setUp(self):
diff --git a/tests/test_models.py b/tests/test_models.py
index 9a96785..5ad49d9 100644
--- a/tests/test_models.py
+++ b/tests/test_models.py
@@ -23,8 +23,10 @@
 import unittest
 
 from freshmaker import db, events
-from freshmaker.models import Event, ArtifactBuild, EventState
+from freshmaker.models import ArtifactBuild, ArtifactType
+from freshmaker.models import Event, EventState, EVENT_TYPES, EventDependency
 from freshmaker.types import ArtifactBuildState
+from freshmaker.events import ErrataAdvisoryRPMsSignedEvent
 
 
 class TestModels(unittest.TestCase):
@@ -177,3 +179,101 @@ class TestModels(unittest.TestCase):
         event = Event.create(db.session, "test_msg_id1", "test", 1024)
         self.assertEqual(
             str(event), "<UnknownEventType 1024, search_key=test>")
+
+
+class TestFindDependentEvents(unittest.TestCase):
+    """Test Event.find_dependent_events"""
+
+    def setUp(self):
+        db.session.remove()
+        db.drop_all()
+        db.create_all()
+        db.session.commit()
+
+        self.event_1 = Event.create(
+            db.session, 'msg-1', 'search-key-1',
+            EVENT_TYPES[ErrataAdvisoryRPMsSignedEvent],
+            state=EventState.INITIALIZED,
+            released=False)
+        ArtifactBuild.create(
+            db.session, self.event_1, 'build-1', ArtifactType.IMAGE)
+        ArtifactBuild.create(
+            db.session, self.event_1, 'build-2', ArtifactType.IMAGE)
+        ArtifactBuild.create(
+            db.session, self.event_1, 'build-3', ArtifactType.IMAGE)
+        ArtifactBuild.create(
+            db.session, self.event_1, 'build-4', ArtifactType.IMAGE)
+
+        self.event_2 = Event.create(
+            db.session, 'msg-2', 'search-key-2',
+            EVENT_TYPES[ErrataAdvisoryRPMsSignedEvent],
+            state=EventState.BUILDING,
+            released=False)
+        ArtifactBuild.create(
+            db.session, self.event_2, 'build-2', ArtifactType.IMAGE)
+        ArtifactBuild.create(
+            db.session, self.event_2, 'build-5', ArtifactType.IMAGE)
+        ArtifactBuild.create(
+            db.session, self.event_2, 'build-6', ArtifactType.IMAGE)
+
+        self.event_3 = Event.create(
+            db.session, 'msg-3', 'search-key-3',
+            EVENT_TYPES[ErrataAdvisoryRPMsSignedEvent],
+            state=EventState.COMPLETE,
+            released=False)
+        ArtifactBuild.create(
+            db.session, self.event_3, 'build-2', ArtifactType.IMAGE)
+        ArtifactBuild.create(
+            db.session, self.event_3, 'build-4', ArtifactType.IMAGE)
+        ArtifactBuild.create(
+            db.session, self.event_3, 'build-7', ArtifactType.IMAGE)
+        ArtifactBuild.create(
+            db.session, self.event_3, 'build-8', ArtifactType.IMAGE)
+
+        # Some noises
+
+        # Failed events should not be included
+        self.event_4 = Event.create(
+            db.session, 'msg-4', 'search-key-4',
+            EVENT_TYPES[ErrataAdvisoryRPMsSignedEvent],
+            state=EventState.FAILED,
+            released=False)
+        ArtifactBuild.create(
+            db.session, self.event_4, 'build-3', ArtifactType.IMAGE)
+
+        # Manual triggered rebuild should not be included as well
+        self.event_5 = Event.create(
+            db.session, 'msg-5', 'search-key-5',
+            EVENT_TYPES[ErrataAdvisoryRPMsSignedEvent],
+            state=EventState.BUILDING,
+            released=False, manual=True)
+        ArtifactBuild.create(
+            db.session, self.event_5, 'build-4', ArtifactType.IMAGE)
+
+        # Released event should not be included also
+        self.event_6 = Event.create(
+            db.session, 'msg-6', 'search-key-6',
+            EVENT_TYPES[ErrataAdvisoryRPMsSignedEvent],
+            state=EventState.COMPLETE,
+            released=True)
+        ArtifactBuild.create(
+            db.session, self.event_5, 'build-4', ArtifactType.IMAGE)
+
+        db.session.commit()
+
+    def tearDown(self):
+        db.session.remove()
+        db.drop_all()
+        db.session.commit()
+
+    def test_find_dependent_events(self):
+        dep_events = self.event_1.find_dependent_events()
+        self.assertEqual([self.event_2.id, self.event_3.id],
+                         sorted([event.id for event in dep_events]))
+
+        dep_rels = db.session.query(EventDependency).all()
+        dep_rels = [(rel.event_id, rel.event_dependency_id) for rel in dep_rels]
+
+        self.assertEqual(2, len(dep_rels))
+        self.assertIn((self.event_1.id, self.event_2.id), dep_rels)
+        self.assertIn((self.event_1.id, self.event_3.id), dep_rels)

